=== debian/changelog ===
alkimia (8.2.1+p24.04+vstable+git20251001.1129-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 01 Oct 2025 11:29:40 +0000
