=== debian/changelog ===
alkimia (8.2.1+p24.04+vstable+git20251015.1250-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 15 Oct 2025 12:50:52 +0000
