## alkimia 8.2.1+p24.04+vstable+git20251020.0622

=== debian/changelog ===
alkimia (8.2.1+p24.04+vstable+git20251020.0622-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 20 Oct 2025 06:22:23 +0000
