## alkimia 8.2.1+p24.04+vstable+git20251123.0933

=== debian/changelog ===
alkimia (8.2.1+p24.04+vstable+git20251123.0933-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 23 Nov 2025 09:33:21 +0000
