## alkimia 8.2.1+p24.04+vstable+git20260131.0024

=== debian/changelog ===
alkimia (8.2.1+p24.04+vstable+git20260131.0024-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sat, 31 Jan 2026 00:24:17 +0000
