## alkimia 8.2.1+p24.04+vstable+git20260216.0225

=== debian/changelog ===
alkimia (8.2.1+p24.04+vstable+git20260216.0225-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 16 Feb 2026 02:25:25 +0000
