## alkimia 8.2.1+p24.04+vstable+git20260219.0355

=== debian/changelog ===
alkimia (8.2.1+p24.04+vstable+git20260219.0355-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 19 Feb 2026 03:55:54 +0000
