## alkimia 8.2.1+p24.04+vunstable+git20260205.0748

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
     cmake_policy(SET CMP0071 NEW)
 endif()
 
-project(alkimia VERSION 8.2.1)
+project(alkimia VERSION 8.2.70)
 
 find_package(ECM 0.0.11 REQUIRED NO_MODULE)
 list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules ${ECM_MODULE_PATH})
