=== debian/changelog ===
alkimia (8.2.1+p24.04+vunstable+git20260205.0748-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 05 Feb 2026 07:48:46 +0000
